#include <stdio.h>
#include <stdlib.h>
#include <string.h>

// Get/Set OpenPandora LED lights (and backlight). LGPL FBnil @2014

// gcc a.c (or a good makefile, run 'make' in codeblocks)
// chown root:users op_leds
// chmod 4750 op_leds
// ln -s ./op_leds op_backlight


// antihack (no access to topdir, could be done better)
void potato(char *a){
	for(int n=0;n<strlen(a);n++)
	{
		if(a[n] == '/' || a[n] == '&' || a[n] == '\\' || a[n] == ';' || a[n] == '`' ){
			printf("potato");
			exit(1);
		}
	}
}

int main(int argc, char *argv[]){
	
	// decide op_leds or op_backlight on last letter
	int leds = (argv[0][strlen(argv[0])-1] == 's');

	// print usage
	if (argc < 3) {
		if(leds){
			printf("%s charger brightness 1\nSee /sys/class/leds/\n", argv[0]);
		}else{
			printf("%s backlight brightness 1\nSee /sys/class/backlight/pandora-backlight/\n", argv[0]);
		}
        return 0;
    }

    char fname[64];
    // do we read or write to the led/background
    int rw = (argv[3] == NULL);

	// check for misusage
    potato(argv[1]);
    potato(argv[2]);

	// join the parameters to fname, buffer overflow save
	if(leds){
		snprintf(fname, sizeof(fname), "/sys/class/leds/pandora::%s/%s", argv[1],argv[2] );
	}else{
		snprintf(fname, sizeof(fname), "/sys/class/backlight/pandora-%s/%s", argv[1],argv[2] );
	}

	//printf("opening '%s'\n",fname);
	FILE *f = fopen(fname, rw? "r":"w");

	if (f == NULL){
		perror("File Open Error");
		exit(1);
	}

	if(rw) {
		// read the value (integers only)
		int v = 0;
		fscanf(f, "%i", &v);
		printf("%i", v);
	}else{
		// write the value
		fprintf(f, "%i\n",atoi(argv[3]));
	}
	
	fclose(f);
	
	return 0;
}
